Uses of Annotation Interface
io.helidon.config.metadata.ConfiguredOption
Packages that use ConfiguredOption
Package
Description
HTTP APIs and implementations usable by both server and client side of the HTTP story.
Defines the Helidon metrics API so Helidon metrics-capable components can implement metrics simply and without regard for
whether metrics is actually on the runtime path or not or is enabled or not.
Security
Attribute based access control (ABAC) security provider.
Common classes for provider implementation.
Provider that can extract username from a (any) header.
Basic security provider with role support and optional outbound propagation.
Provider supporting validation of incoming signatures and signing of outbound requests.
Mapper that retrieves roles from IDCS server and maps them to user subject.
Provider that can process incoming JWTs and assert users based on them and can propagate JWTs (or create
new ones) for outbound calls.
Integration with Open ID Connect providers.
Open ID Connect (OIDC) classes usable from all OIDC related components.
General utilities for security modules.
Distributed tracing support for Helidon.
Helidon WebClient APIs shared by all types of clients.
-
Uses of ConfiguredOption in io.helidon.http
Methods in io.helidon.http with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionRequestedUriDiscoveryContext.Builder.enabled(boolean value) Sets whether requested URI discovery is enabled for requestes arriving on the socket.RequestedUriDiscoveryContext.Builder.trustedProxies(AllowList trustedProxies) Sets the trusted proxies for requested URI discovery for requests arriving on the socket.RequestedUriDiscoveryContext.Builder.types(List<RequestedUriDiscoveryContext.RequestedUriDiscoveryType> discoveryTypes) Sets the discovery types for requested URI discovery for requests arriving on the socket. -
Uses of ConfiguredOption in io.helidon.metrics.api
Methods in io.helidon.metrics.api with annotations of type ConfiguredOption -
Uses of ConfiguredOption in io.helidon.security
Methods in io.helidon.security with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionSecurity.Builder.addProvider(SecurityProvider provider) Add a provider, works asSecurity.Builder.addProvider(io.helidon.security.spi.SecurityProvider, String), where the name is set toClass.getSimpleName().Security.Builder.authenticationProvider(AuthenticationProvider provider) Set the default authentication provider.Security.Builder.authorizationProvider(AuthorizationProvider provider) Set the default authorization provider.Security.Builder.enabled(boolean enabled) Security can be disabled using configuration, or explicitly.Security.Builder.serverTime(SecurityTime time) Server time to use when evaluating security policies that depend on time.SecurityTime.Builder.shiftBySeconds(long seconds) Configure a time-shift in seconds, to move the current time to past or future.Override current time zone.Security.Builder.tracingEnabled(boolean tracingEnabled) Whether or not tracing should be enabled. -
Uses of ConfiguredOption in io.helidon.security.providers.abac
Methods in io.helidon.security.providers.abac with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionAbacProvider.Builder.failIfNoneValidated(boolean failIfNoneValidated) Whether to fail if NONE of the attributes is validated.AbacProvider.Builder.failOnUnvalidated(boolean failOnUnvalidated) Whether to fail if any attribute is left unvalidated. -
Uses of ConfiguredOption in io.helidon.security.providers.common
Methods in io.helidon.security.providers.common with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionAdd supported host for this target.Add an exactly matched supported method for this target.Add supported paths for this target.OutboundConfig.Builder.addTarget(OutboundTarget config) Add a new target configuration.OutboundTarget.Builder.addTransport(String transport) Add supported transports for this target.EvictableCache.Builder.cacheEnabled(boolean cacheEnabled) If the cacheEnabled is set to false, no caching will be done.EvictableCache.Builder.evictor(BiFunction<K, V, Boolean> evictor) Configure evictor to check if a record is still valid.EvictableCache.Builder.maxSize(long cacheMaxSize) Configure maximal cache size.Configure the name of this outbound target.EvictableCache.Builder.overallTimeout(long timeout, TimeUnit timeoutUnit) Configure record timeout since its creation.EvictableCache.Builder.parallelismThreshold(long parallelismThreshold) Configure parallelism threshold.Configure record timeout since last access. -
Uses of ConfiguredOption in io.helidon.security.providers.header
Methods in io.helidon.security.providers.header with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionHeaderAtnProvider.Builder.addOutboundTarget(OutboundTarget target) Configure outbound target for identity propagation.HeaderAtnProvider.Builder.atnTokenHandler(TokenHandler tokenHandler) Token handler to extract username from request.HeaderAtnProvider.Builder.authenticate(boolean authenticate) Whether to authenticate requests.HeaderAtnProvider.Builder.optional(boolean optional) Whether authentication is required.HeaderAtnProvider.Builder.outboundTokenHandler(TokenHandler tokenHandler) Token handler to create outbound headers to propagate identity.HeaderAtnProvider.Builder.propagate(boolean propagate) Whether to propagate identity.HeaderAtnProvider.Builder.subjectType(SubjectType subjectType) Principal type this provider extracts (and also propagates). -
Uses of ConfiguredOption in io.helidon.security.providers.httpauth
Methods in io.helidon.security.providers.httpauth with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionHttpBasicAuthProvider.Builder.addOutboundTarget(OutboundTarget target) Add a new outbound target to configure identity propagation or explicit username/password.HttpBasicAuthProvider.Builder.optional(boolean optional) Whether authentication is required.Set the realm to use when challenging users.HttpBasicAuthProvider.Builder.subjectType(SubjectType subjectType) Principal type this provider extracts (and also propagates).HttpBasicAuthProvider.Builder.userStore(SecureUserStore store) Set user store to validate users. -
Uses of ConfiguredOption in io.helidon.security.providers.httpsign
Methods in io.helidon.security.providers.httpsign with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionHttpSignProvider.Builder.addAcceptHeader(HttpSignHeader header) Add a header that is validated on inbound requests.HttpSignProvider.Builder.addInbound(InboundClientDefinition client) Add inbound configuration.Algorithm of signature used by this client.HttpSignProvider.Builder.backwardCompatibleEol(Boolean backwardCompatible) Enable support for Helidon versions before 3.0.0 (exclusive).InboundClientDefinition.Builder.hmacSecret(String secret) Helper method to configure a password-like secret (instead of byte basedInboundClientDefinition.Builder.hmacSecret(byte[]).HttpSignProvider.Builder.inboundDateValidity(Duration inboundDateValidity) Configure the maximum accepted age or future skew for the signedDateheader.HttpSignProvider.Builder.inboundRequiredHeaders(SignedHeadersConfig inboundRequiredHeaders) Override the default inbound required headers (e.g.The key id of this client to map to this signature validation configuration.HttpSignProvider.Builder.optional(boolean optional) Set whether the signature is optional.HttpSignProvider.Builder.outbound(OutboundConfig targets) Add outbound targets to this builder.InboundClientDefinition.Builder.principalName(String name) The principal name of the client, defaults to keyId if not configured.InboundClientDefinition.Builder.publicKeyConfig(Keys keyConfig) For algorithms based on public/private key (such as rsa-sha256), this provides access to the public key of the client.Realm to use for challenging inbound requests that do not have "Authorization" header in case header isHttpSignHeader.AUTHORIZATIONand singatures are not optional.InboundClientDefinition.Builder.subjectType(SubjectType type) The type of principal we have authenticated (either user or service, defaults to service). -
Uses of ConfiguredOption in io.helidon.security.providers.idcs.mapper
Methods in io.helidon.security.providers.idcs.mapper with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionIdcsRoleMapperProviderBase.Builder.addSubjectType(SubjectType type) Add a supported subject type.IdcsMtRoleMapperProvider.Builder.cache(EvictableCache<IdcsMtRoleMapperProvider.MtCacheKey, List<Grant>> roleCache) Use explicitEvictableCachefor role caching.IdcsRoleMapperProviderBase.Builder.defaultIdcsSubjectType(String subjectType) Configure subject type to use when requesting roles from IDCS.IdcsMtRoleMapperProvider.Builder.idcsAppNameTokenHandler(TokenHandler idcsAppNameTokenHandler) Configure token handler for IDCS Application name.IdcsMtRoleMapperProvider.Builder.idcsTenantTokenHandler(TokenHandler idcsTenantTokenHandler) Configure token handler for IDCS Tenant ID.IdcsRoleMapperProviderBase.Builder.oidcConfig(OidcConfig config) Use explicitOidcConfiginstance, e.g.IdcsRoleMapperProvider.Builder.roleCache(EvictableCache<String, List<Grant>> roleCache) Use explicitEvictableCachefor role caching. -
Uses of ConfiguredOption in io.helidon.security.providers.jwt
Methods in io.helidon.security.providers.jwt with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionJwtProvider.Builder.allowImpersonation(boolean allowImpersonation) Whether to allow impersonation by explicitly overriding username from outbound requests usingEndpointConfig.PROPERTY_OUTBOUND_IDproperty.JwtProvider.Builder.allowUnsigned(boolean allowUnsigned) Configure support for unsigned JWTs without requiring verification JWKs.JwtProvider.Builder.atnTokenHandler(TokenHandler tokenHandler) Token handler to extract username from request.JwtProvider.Builder.authenticate(boolean authenticate) Whether to authenticate requests.voidJwtProvider.Builder.expectedAudience(String audience) Audience expected in inbound JWTs.JwtProvider.Builder.expectedIssuer(String issuer) Issuer expected in inbound JWTs.Issuer used to create new JWTs.JwtProvider.Builder.jwkCircuitBreaker(CircuitBreaker jwkCircuitBreaker) Circuit breaker around each complete retry batch used to load verification keys from a filesystem path or URI; by default, the circuit opens after one exhausted batch and permits a recovery probe after 5 seconds.Retry used when loading verification keys from a filesystem path or URI; by default, it wraps two timeout-guarded attempts within an 11-second overall timeout.JwtProvider.Builder.jwkTimeout(Timeout jwkTimeout) Timeout applied to each attempt to load verification keys from a filesystem path or URI; it defaults to 5 seconds, must be positive, must execute on the current thread, and must not exceed the retry overall timeout.JwtProvider.Builder.jwtGroupsPath(String jwtGroupsPath) Path to the JWT payload claim containing the groups to add as role grants.JwtProvider.Builder.jwtGroupsSeparator(String jwtGroupsSeparator) Separator used to split a string claim value into multiple groups.JwtProvider.Builder.optional(boolean optional) Whether authentication is required.JwtProvider.Builder.outboundConfig(OutboundConfig config) Configuration of outbound rules.JwtProvider.Builder.propagate(boolean propagate) Whether to propagate identity.JWK resource used to sign JWTs created by us.JwtProvider.Builder.subjectType(SubjectType subjectType) Principal type this provider extracts (and also propagates).JwtProvider.Builder.useJwtGroups(boolean useJwtGroups) Claimgroupsfrom JWT will be used to automatically add groups to current subject (may be used withRolesAllowedannotation).JWK resource used to verify JWTs created by other parties.JwtProvider.Builder.verifySignature(boolean shouldValidate) Configure whether to verify signatures. -
Uses of ConfiguredOption in io.helidon.security.providers.oidc
Methods in io.helidon.security.providers.oidc with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionOidcProvider.Builder.jwtGroupsPath(String jwtGroupsPath) Path to the JWT payload claim containing the groups to add as role grants.OidcProvider.Builder.jwtGroupsSeparator(String jwtGroupsSeparator) Separator used to split a string claim value into multiple groups.OidcProvider.Builder.oidcConfig(OidcConfig config) Configuration of OIDC (Open ID Connect).OidcProvider.Builder.optional(boolean optional) Whether authentication is required.OidcProvider.Builder.outboundConfig(OutboundConfig config) Configuration of outbound rules.OidcProvider.Builder.propagate(boolean propagate) Whether to propagate identity.OidcProvider.Builder.useJwtGroups(boolean useJwtGroups) Claimgroupsfrom JWT will be used to automatically add groups to current subject (may be used withRolesAllowedannotation). -
Uses of ConfiguredOption in io.helidon.security.providers.oidc.common
Methods in io.helidon.security.providers.oidc.common with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionOidcConfig.Builder.accessTokenIpCheck(boolean enabled) Whether to check if current IP address matches the one access token was issued for.OidcConfig.Builder.addTenantConfig(TenantConfig tenantConfig) Add specificTenantConfiginstance.Audience of issued tokens.BaseBuilder.authorizationEndpointUri(URI uri) URI of an authorization endpoint used to redirect users to for logging-in.BaseBuilder.baseScopes(String scopes) Configure base scopes.BaseBuilder.checkAudience(boolean checkAudience) Configure audience claim check.OidcConfig.Builder.clientCredentialsConfig(ClientCredentialsConfig clientCredentialsConfig) Set the configuration related to the client credentials flow.Client ID as generated by OIDC server.BaseBuilder.clientSecret(String clientSecret) Client secret as generated by OIDC server.BaseBuilder.clientTimeout(Duration duration) Timeout of calls using web client.Update this builder with values from configuration.OidcConfig.Builder.cookieCompressionEnabled(boolean cookieCompressionEnabled) Whether to GZIP-compress the access token cookie when this reduces its size.OidcConfig.Builder.cookieCompressionEnabledIdToken(boolean cookieCompressionEnabled) Whether to GZIP-compress the ID token cookie when this reduces its size.OidcConfig.Builder.cookieDomain(String domain) Domain the cookie is valid for.OidcConfig.Builder.cookieEncryptionEnabled(boolean cookieEncryptionEnabled) Whether to encrypt token cookie created by this microservice.OidcConfig.Builder.cookieEncryptionEnabledIdToken(boolean cookieEncryptionEnabled) Whether to encrypt id token cookie created by this microservice.OidcConfig.Builder.cookieEncryptionEnabledRefreshToken(boolean cookieEncryptionEnabled) Whether to encrypt refresh token cookie created by this microservice.OidcConfig.Builder.cookieEncryptionEnabledState(boolean cookieEncryptionEnabled) Whether to encrypt state cookie created by this microservice.OidcConfig.Builder.cookieEncryptionEnabledTenantName(boolean cookieEncryptionEnabled) Whether to encrypt tenant name cookie created by this microservice.OidcConfig.Builder.cookieEncryptionName(String cookieEncryptionName) Name of the encryption configuration available throughSecurity.encrypt(String, byte[])andSecurity.decrypt(String, String).OidcConfig.Builder.cookieEncryptionPassword(char[] cookieEncryptionPassword) Master password for encryption/decryption of cookies.OidcConfig.Builder.cookieHttpOnly(Boolean httpOnly) When using cookie, if set to true, the HttpOnly attribute will be configured.OidcConfig.Builder.cookieMaxAgeSeconds(long age) When using cookie, used to set MaxAge attribute of the cookie, defining how long the cookie is valid.OidcConfig.Builder.cookieName(String cookieName) Name of the cookie to use.OidcConfig.Builder.cookieNameIdToken(String cookieName) Name of the cookie to use for id token.OidcConfig.Builder.cookieNameRefreshToken(String cookieName) The name of the cookie to use for the refresh token.OidcConfig.Builder.cookieNameState(String cookieName) The name of the cookie to use for the state storage.OidcConfig.Builder.cookiePath(String path) Path the cookie is valid for.OidcConfig.Builder.cookieSameSite(SetCookie.SameSite sameSite) When using cookie, used to set the SameSite cookie value.OidcConfig.Builder.cookieSecure(Boolean secure) When using cookie, if set to true, the Secure attribute will be configured.OidcConfig.Builder.cookieTenantName(String cookieName) The name of the cookie to use for the tenant name.BaseBuilder.decryptionKeys(Resource resource) A resource pointing to JWK with private keys used for JWE content key decryption.OidcConfig.Builder.fallbackToDefaultTenantEnabled(boolean enabled) Whether unknown tenant ids should use default tenant configuration.OidcConfig.Builder.forceHttpsRedirects(boolean forceHttpsRedirects) Force HTTPS for redirects to identity provider.OidcConfig.Builder.frontendUri(String uri) Full URI of this application that is visible from user browser.OidcConfig.Builder.headerTokenHandler(TokenHandler tokenHandler) ATokenHandlerto process header containing a JWT.BaseBuilder.identityUri(URI uri) URI of the identity server, base used to retrieve OIDC metadata.OidcConfig.Builder.idTokenParamName(String idTokenParamName) Name of a query parameter that contains the JWT id token when parameter is used.OidcConfig.Builder.idTokenSignatureValidation(boolean enabled) Whether id token signature check should be enabled.BaseBuilder.introspectEndpointUri(URI uri) Endpoint to use to validate JWT.Issuer of issued tokens.BaseBuilder.jwkCircuitBreaker(CircuitBreaker jwkCircuitBreaker) Circuit breaker around each complete retry batch used to load OIDC metadata and signing JWKs; by default, the circuit opens after one exhausted batch and permits a recovery probe after 5 seconds.OidcConfig.Builder.jwkCircuitBreaker(CircuitBreaker jwkCircuitBreaker) Retry used while loading OIDC metadata and signing JWKs; by default, it wraps two timeout-guarded attempts within an 11-second overall timeout.BaseBuilder.jwkTimeout(Timeout jwkTimeout) Timeout applied to each attempt to load OIDC metadata and signing JWKs; it defaults to 5 seconds, must be positive, must execute on the current thread, and must not exceed the retry overall timeout.OidcConfig.Builder.jwkTimeout(Timeout jwkTimeout) OidcConfig.Builder.legacyCookieEncryption(boolean legacyCookieEncryption) Whether password-based encrypted OIDC cookies should be written without a version byte and with the legacy PBKDF2 iteration count.OidcConfig.Builder.legacyCookieFallback(boolean legacyCookieFallback) Whether password-based encrypted OIDC cookies should retry decryption with the alternate cookie format after primary decryption fails.OidcConfig.Builder.maxRedirects(int maxRedirects) Configure maximal number of redirects when redirecting to an OIDC provider within a single authentication attempt.Name of the tenant.BaseBuilder.oidcMetadata(Resource resource) Resource configuration for OIDC Metadata containing endpoints to various identity services, as well as information about the identity server.BaseBuilder.oidcMetadataWellKnown(boolean useWellKnown) If set to true, metadata will be loaded from default (well known) location, unless it is explicitly defined using oidc-metadata-resource.BaseBuilder.optionalAudience(boolean optional) Allow audience claim to be optional.Name of a query parameter that contains the JWT access token when parameter is used.OidcConfig.Builder.paramTenantName(String paramName) Name of a query parameter that contains the tenant name when the parameter is used.OidcConfig.Builder.pkceChallengeMethod(PkceChallengeMethod pkceChallengeMethod) Proof Key Code Exchange (PKCE) challenge creation method.OidcConfig.Builder.pkceEnabled(boolean enabled) Whether this provider should support PKCE.OidcConfig.Builder.redirect(boolean redirect) By default, the client should redirect to the identity server for the user to log in.OidcConfig.Builder.redirectAttemptCounterStrategy(RedirectAttemptCounterStrategy strategy) Configure the strategy used to count redirects to an identity server.OidcConfig.Builder.redirectAttemptParam(String paramName) Configure the redirect attempt query parameter and cookie name prefix.OidcConfig.Builder.redirectUri(String redirectUri) URI to register web server component on, used by the OIDC server to redirect authorization requests to after a user logs in or approves scopes.BaseBuilder.scopeAudience(String audience) Audience of the scope required by this application.BaseBuilder.serverType(String type) Configure one of the supported types of identity servers.A resource pointing to JWK with public keys of signing certificates used to validate JWT.BaseBuilder.tokenEndpointAuthentication(OidcConfig.ClientAuthentication tokenEndpointAuthentication) Type of authentication to use when invoking the token endpoint.BaseBuilder.tokenEndpointUri(URI uri) URI of a token endpoint used to obtain a JWT based on the authentication code.OidcConfig.Builder.tokenSignatureValidation(boolean enabled) Whether access token signature check should be enabled.Whether to use cookie to store JWT between requests.Whether to expect JWT in a header field.Whether to use a query parameter to send JWT token from application to this server.BaseBuilder.validateJwtWithJwk(Boolean useJwk) Use JWK (a set of keys to validate signatures of JWT) to validate tokens. -
Uses of ConfiguredOption in io.helidon.security.util
Methods in io.helidon.security.util with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionTokenHandler.Builder.tokenFormat(String format) Token format for creating outbound tokens.TokenHandler.Builder.tokenHeader(String header) Set the name of header to look into to extract the token.TokenHandler.Builder.tokenPattern(Pattern pattern) Set the token pattern (Regular expression) to extract the token.TokenHandler.Builder.tokenPrefix(String prefix) Set the prefix of header value to extract the token. -
Uses of ConfiguredOption in io.helidon.tracing
Methods in io.helidon.tracing with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionTracerBuilder.addTracerTag(String key, boolean value) Tracer level tags that get added to all reported spans.TracerBuilder.addTracerTag(String key, Number value) Tracer level tags that get added to all reported spans.TracerBuilder.addTracerTag(String key, String value) Tracer level tags that get added to all reported spans.TracerBuilder.collectorHost(String host) Host to use to connect to tracing collector.TracerBuilder.collectorPath(String path) Path on the collector host to use when sending data to tracing collector.TracerBuilder.collectorPort(int port) Port to use to connect to tracing collector.TracerBuilder.collectorProtocol(String protocol) Protocol to use (such ashttporhttps) to connect to tracing collector.TracerBuilder.enabled(boolean enabled) When enabled, tracing will be sent.TracerBuilder.registerGlobal(boolean global) Whether the OpenTelemetry instance created by this tracer builder should be published toGlobalOpenTelemetry.TracerBuilder.serviceName(String name) Service name of the traced service. -
Uses of ConfiguredOption in io.helidon.webclient.api
Methods in io.helidon.webclient.api with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionProxy.Builder.addNoProxy(String noProxyHost) Configure a host or IP pattern that is not going through a proxy; IP patterns resolve host-name targets locally and bind direct routes to the matching address.Proxy.Builder.forceHttpConnect(boolean forceHttpConnect) Forces HTTP CONNECT with the proxy server.Sets a new host value.Proxy.Builder.password(char[] password) Sets a new password for the proxy.Proxy.Builder.port(int port) Sets a port value.Proxy.Builder.type(Proxy.ProxyType type) Sets a new proxy type.Sets a new username for the proxy.